## syncthingtray 1.7.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17.0 FATAL_ERROR)

# define metadata
set(META_PROJECT_NAME syncthingtray)
set(META_APP_AUTHOR "Martchus")
set(META_APP_AUTHOR_MAIL "martchus@gmx.net")
set(META_APP_URL "https://${META_APP_AUTHOR}.github.io/${META_PROJECT_NAME}")
set(META_APP_URL_RAW "https://raw.githubusercontent.com/${META_APP_AUTHOR}/${META_PROJECT_NAME}/master")
set(META_APP_BUGTRACKER_URL "https://github.com/${META_APP_AUTHOR}/${META_PROJECT_NAME}/issues")
set(META_APP_DESCRIPTION "Tray application for Syncthing")
set(META_APP_CATEGORIES "Network;FileTransfer")
set(META_GUI_OPTIONAL false)
set(META_VERSION_MAJOR 1)
set(META_VERSION_MINOR 7)
set(META_VERSION_PATCH 5)
set(META_RELEASE_DATE "2025-04-04")
set(META_SOVERSION 23)
set(META_ADD_DEFAULT_CPP_UNIT_TEST_APPLICATION ON)
set(NETWORK_INFORMATION_SUPPORT ON)

project(${META_PROJECT_NAME})
enable_testing()

# disable experimental Qt Quick GUI by default except on mobile platforms, enable libsyncthing by default
if (ANDROID OR IOS)
    set(WIDGET_GUI_ENABLED_BY_DEFAULT OFF)
    set(QUICK_GUI_ENABLED_BY_DEFAULT ON)
    set(LIBSYNCTHING_DISABLED_BY_DEFAULT OFF)
else ()
    set(WIDGET_GUI_ENABLED_BY_DEFAULT ON)
    set(QUICK_GUI_ENABLED_BY_DEFAULT OFF)
    set(LIBSYNCTHING_DISABLED_BY_DEFAULT ON)
endif ()

# disable KDE integration under Android, Windows and MacOS by default
if(ANDROID OR WIN32 OR APPLE)
    set(FILE_ITEM_ACTION_PLUGIN_DISABLED_BY_DEFAULT ON)
    set(PLASMOID_DISABLED_BY_DEFAULT ON)
else()
    set(FILE_ITEM_ACTION_PLUGIN_DISABLED_BY_DEFAULT OFF)
    set(PLASMOID_DISABLED_BY_DEFAULT OFF)
endif()

# determine Qt and KDE Frameworks version bases on the package prefix
set(QT_PACKAGE_PREFIX
    "Qt5"
    CACHE STRING "specifies the prefix for Qt packages")
set(KF_PACKAGE_PREFIX
    "KF5"
    CACHE STRING "specifies the prefix for KDE Frameworks packages")
set(QT_MAJOR_VERSION 5)
if (QT_PACKAGE_PREFIX MATCHES ".*Qt([0-9]+).*")
    set(QT_MAJOR_VERSION "${CMAKE_MATCH_1}")
endif ()
set(KF_MAJOR_VERSION 5)
if (KF_PACKAGE_PREFIX MATCHES ".*KF([0-9]+).*")
    set(KF_MAJOR_VERSION "${CMAKE_MATCH_1}")
endif ()

# add options for partial build
option(NO_LIBSYNCTHING "whether building Syncthing itself as a library should be skipped" "${LIBSYNCTHING_DISABLED_BY_DEFAULT}")
option(NO_CLI "whether building CLI should be skipped" OFF)
option(NO_TRAY "whether building the tray should be skipped" OFF)
option(NO_FILE_ITEM_ACTION_PLUGIN "whether building the file item action plugin should be skipped" "${FILE_ITEM_ACTION_PLUGIN_DISABLED_BY_DEFAULT}")
option(NO_MODEL "whether building models should be skipped, implies NO_TRAY" OFF)
option(NO_WIDGETS "whether building widgets should be skipped, implies NO_TRAY" OFF)
option(NO_PLASMOID "whether building the Plasmoid for the Plasma desktop should be skipped" "${PLASMOID_DISABLED_BY_DEFAULT}")
option(WIDGETS_GUI "enables/disables building the Qt Widgets GUI (disabled by default)" ${WIDGET_GUI_ENABLED_BY_DEFAULT})
option(QUICK_GUI "enables/disables building the experimental Qt Quick GUI (disabled by default)" ${QUICK_GUI_ENABLED_BY_DEFAULT})

# allow using non-default configuration
set(CONFIGURATION_PACKAGE_SUFFIX "" CACHE STRING "sets the suffix for find_package() calls to packages configured via c++utilities")
set(CONFIGURATION_PACKAGE_SUFFIX_QTUTILITIES "${CONFIGURATION_PACKAGE_SUFFIX}" CACHE STRING "sets the suffix for qtutilities")
set(CONFIGURATION_PACKAGE_SUFFIX_QTFORKAWESOME "${CONFIGURATION_PACKAGE_SUFFIX_QTUTILITIES}" CACHE STRING "sets the suffix for qtforkawesome")

# allow building qtforkawesome as part of this project
set(BUNDLED_QT_FORK_AWESOME_PATH OFF CACHE PATH "specifies the (relative) path to the qtforkawesome sources for building it together with ${META_PROJECT_NAME}")
if(NOT BUNDLED_QT_FORK_AWESOME_PATH)
    message(STATUS "Using system qtforkawesome")
else()
    if(IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/${BUNDLED_QT_FORK_AWESOME_PATH}" OR IS_DIRECTORY "${BUNDLED_QT_FORK_AWESOME_PATH}")
        add_subdirectory("${BUNDLED_QT_FORK_AWESOME_PATH}" qtforkawesome)
        set(${NAMESPACE_PREFIX}qtforkawesome${CONFIGURATION_PACKAGE_SUFFIX_QTFORKAWESOME}_DIR "${CMAKE_CURRENT_BINARY_DIR}/qtforkawesome/qtforkawesome")
        set(${NAMESPACE_PREFIX}qtquickforkawesome${CONFIGURATION_PACKAGE_SUFFIX_QTFORKAWESOME}_DIR "${CMAKE_CURRENT_BINARY_DIR}/qtforkawesome/qtquickforkawesome")
        set(${NAMESPACE_PREFIX}qtforkawesomeiconengine${CONFIGURATION_PACKAGE_SUFFIX_QTFORKAWESOME}_DIR "${CMAKE_CURRENT_BINARY_DIR}/qtforkawesome/iconengineplugin")
    else()
        message(FATAL_ERROR "Specified directory for qtforkawesome sources \"${BUNDLED_QT_FORK_AWESOME_PATH}\" does not exist.")
    endif()
endif()

set(PACKAGE_NAMESPACE "" CACHE STRING "sets the prefix for find_package() calls to packages configured via c++utilities")
if (PACKAGE_NAMESPACE)
  set(PACKAGE_NAMESPACE_PREFIX "${PACKAGE_NAMESPACE}-")
endif ()

# add subdirectories
add_subdirectory(syncthingconnector)
add_subdirectory(testhelper)
if (NOT NO_LIBSYNCTHING)
    add_subdirectory(syncthing)
endif()
link_directories(${LIB_SYNCTHING_CONNECTOR_BINARY_DIR})
if(NOT NO_CLI)
    add_subdirectory(cli)
endif()
if(NOT NO_MODEL)
    add_subdirectory(syncthingmodel)
    link_directories(${LIB_SYNCTHING_MODEL_BINARY_DIR})
    if(NOT NO_WIDGETS)
        add_subdirectory(syncthingwidgets)
        if(NOT NO_TRAY)
            add_subdirectory(tray)
        endif()
        if(NOT NO_PLASMOID)
            add_subdirectory(plasmoid)
        endif()
    endif()
endif()
if(NOT NO_FILE_ITEM_ACTION_PLUGIN)
    add_subdirectory(fileitemactionplugin)
endif()

=== plasmoid/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17.0)

# meta data
set(META_PROJECT_NAME syncthingplasmoid)
set(META_APP_NAME "Syncthing Plasmoid")
set(META_APP_DESCRIPTION "Plasmoid to interact with Syncthing")
set(META_PROJECT_TYPE qtplugin)
set(META_PLUGIN_CATEGORY plasma/applets)
set(META_QT5_VERSION 5.8)

# use testfiles directory from syncthingconnector
set(META_SRCDIR_REFS "${CMAKE_CURRENT_SOURCE_DIR}\n${CMAKE_CURRENT_SOURCE_DIR}/../syncthingconnector")

# find Plasma and its dependencies (which are not pulled-in automatically as of Plasma 6)
if (KF_MAJOR_VERSION GREATER_EQUAL 6)
    find_package(Plasma REQUIRED)
    find_package(${QT_PACKAGE_PREFIX}Qml REQUIRED)
    find_package(${KF_PACKAGE_PREFIX}Config REQUIRED)
else ()
    find_package(${KF_PACKAGE_PREFIX}Plasma REQUIRED)
endif ()

# define list of QML files; there is a distinct directory for each major Plasma version
set(PLASMOID_FILE_NAMES
    CompactRepresentation.qml
    FullRepresentation.qml
    DirectoriesPage.qml
    DevicesPage.qml
    DownloadsPage.qml
    RecentChangesPage.qml
    TopLevelView.qml
    TopLevelItem.qml
    DetailView.qml
    DetailItem.qml
    TabButton.qml
    ToolTipTrigger.qml
    ToolTipView.qml
    ToolBar.qml
    ToolButton.qml
    TinyButton.qml
    IconLabel.qml
    StatisticsView.qml
    main.qml)
set(PLASMOID_FILES_BASE "package${KF_MAJOR_VERSION}")
set(PLASMOID_FILES_UI "${PLASMOID_FILES_BASE}/contents/ui")
foreach (PLASMOID_FILE_NAME ${PLASMOID_FILE_NAMES})
    list(APPEND PLASMOID_FILES "${PLASMOID_FILES_UI}/${PLASMOID_FILE_NAME}")
endforeach ()
file(GLOB_RECURSE PLASMOID_EXCLUDED_FILES LIST_DIRECTORIES false RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "package*/*.qml")
list(REMOVE_ITEM PLASMOID_EXCLUDED_FILES ${PLASMOID_FILES})

# find ECM (required by Plasma)
find_package(ECM REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR} ${CMAKE_MODULE_PATH})

# find c++utilities
find_package(${PACKAGE_NAMESPACE_PREFIX}c++utilities${CONFIGURATION_PACKAGE_SUFFIX} 5.20.0 REQUIRED)
list(APPEND CMAKE_MODULE_PATH ${CPP_UTILITIES_MODULE_DIRS})

# prepare plasmoid package/configuration
set(PLASMOID_PACKAGE_DIR "${CMAKE_CURRENT_BINARY_DIR}/package")
file(MAKE_DIRECTORY "${PLASMOID_PACKAGE_DIR}")
if (KF_MAJOR_VERSION LESS 6)
    set(PLASMOID_CONFIG_TARGET_FILE "${PLASMOID_PACKAGE_DIR}/metadata.desktop")
else ()
    set(PLASMOID_CONFIG_TARGET_FILE "${PLASMOID_PACKAGE_DIR}/metadata.json")
endif ()

# make plugin library
add_subdirectory(lib)

# make plasmoid configuration
include(TemplateFinder)
if (KF_MAJOR_VERSION LESS 6)
    find_template_file("metadata.desktop" "${META_PROJECT_NAME}" PLASMOID_CONFIG_TEMPLATE_FILE)
else ()
    find_template_file("metadata.json" "${META_PROJECT_NAME}" PLASMOID_CONFIG_TEMPLATE_FILE)
endif ()
get_filename_component(PLASMOID_CONFIG_TARGET_FILE_ABSOLUTE_PATH "${PLASMOID_CONFIG_TARGET_FILE}" REALPATH BASE_DIR "${CMAKE_BINARY_DIR}")
configure_file("${PLASMOID_CONFIG_TEMPLATE_FILE}" "${PLASMOID_CONFIG_TARGET_FILE}")

# copy plasmoid package folder plus metadata file into build directory and install it from there
foreach (PLASMOID_FILE ${PLASMOID_FILES})
    get_filename_component(PLASMOID_FILE_DIR "${PLASMOID_FILE}" DIRECTORY)
    string(REGEX REPLACE "package[0-9]+" "package" PLASMOID_FILE_DIR "${PLASMOID_FILE_DIR}")
    file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/${PLASMOID_FILE_DIR}")
    file(COPY "${PLASMOID_FILE}" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}/${PLASMOID_FILE_DIR}")
endforeach ()
plasma_install_package("${PLASMOID_PACKAGE_DIR}" "${META_ID}")

# add target to ease testing the plasmoid - using files from source directory directly instead of
# copy in build directory so one does not need to run CMake again to apply changes (see testing.md)
set(PLASMOID_TESTDIR "${CMAKE_BINARY_DIR}" CACHE STRING "specifies the Plasmoid test directory")
file(MAKE_DIRECTORY "${PLASMOID_TESTDIR}")
add_custom_target(init_plasmoid_testing
    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/scripts/inittesting.sh" "${PLASMOID_CONFIG_TARGET_FILE_ABSOLUTE_PATH}" "${PLASMOID_FILES_BASE}"
    WORKING_DIRECTORY "${PLASMOID_TESTDIR}"
)

=== syncthing/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17.0 FATAL_ERROR)

# metadata
set(META_PROJECT_NAME syncthing)
set(META_PROJECT_TYPE library)
set(META_APP_NAME "Syncthing library")
set(META_APP_DESCRIPTION "Syncthing itself, built as a shared or static library")
set(META_PROJECT_VARNAME_UPPER LIB_SYNCTHING)
set(META_SYNCTHING_VERSION "v1.29.4")

# use testfiles directory from syncthingconnector
set(META_SRCDIR_REFS "${CMAKE_CURRENT_SOURCE_DIR}\n${CMAKE_CURRENT_SOURCE_DIR}/../syncthingconnector")

# add project files
set(HEADER_FILES interface.h)
set(SRC_FILES "${CMAKE_CURRENT_BINARY_DIR}/libsyncthinginternal.h" interface.cpp)

set(TEST_HEADER_FILES)
set(TEST_SRC_FILES tests/interfacetests.cpp)

# find the go binary
find_program(GO_BIN go)
if (NOT GO_BIN)
    message(FATAL_ERROR "The go binary could not be located.")
endif ()

# define environment/args to use tools configured within CMake also with cgo
set(GO_COMPILER_ARGS "CC='${CMAKE_C_COMPILER}'" "CXX='${CMAKE_CXX_COMPILER}'" "AR='${CMAKE_C_COMPILER_AR}'")
if (CMAKE_RANLIB)
    set(GO_RANLIB_ARGS "&&" "${CMAKE_RANLIB}" "${CMAKE_CURRENT_BINARY_DIR}/libsyncthinginternal.a")
endif ()

# determine GOARCH for target
set(GO_TARGET_ARCH_OVERRIDE
    ""
    CACHE STRING "overrides the 'GOARCH' variable")
if (GO_TARGET_ARCH_OVERRIDE)
    set(GO_TARGET_ARCH "${GO_TARGET_ARCH_OVERRIDE}")
elseif (NOT CMAKE_CROSSCOMPILING)
    set(GO_TARGET_ARCH "")
elseif (CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
    set(GO_TARGET_ARCH "amd64")
elseif (CMAKE_SYSTEM_PROCESSOR MATCHES "i[3-6]86")
    set(GO_TARGET_ARCH "386")
elseif (CMAKE_SYSTEM_PROCESSOR MATCHES "aarch64")
    set(GO_TARGET_ARCH "arm64")
elseif (CMAKE_SYSTEM_PROCESSOR MATCHES "arm(v\\d+[a-z]*)?")
    set(GO_TARGET_ARCH "arm")
elseif (CMAKE_SYSTEM_NAME MATCHES "(ppc64|ppc64le|arm|arm64|s390x)")
    set(GO_TARGET_ARCH "${CMAKE_SYSTEM_NAME}")
else ()
    message(
        FATAL_ERROR
            "Unable to auto-determine GOARCH for CMAKE_SYSTEM_PROCESSOR=\"${CMAKE_SYSTEM_PROCESSOR}\". Please set GO_TARGET_ARCH_OVERRIDE manually."
    )
endif ()

# determine GOOS for target
set(GO_TARGET_OS_OVERRIDE
    ""
    CACHE STRING "overrides the 'GOOS' variable")
if (GO_TARGET_OS_OVERRIDE)
    set(GO_TARGET_OS "${GO_TARGET_OS_OVERRIDE}")
elseif (NOT CMAKE_CROSSCOMPILING)
    set(GO_TARGET_OS "")
elseif (CMAKE_SYSTEM_NAME STREQUAL "Linux")
    set(GO_TARGET_OS "linux")
elseif (CMAKE_SYSTEM_NAME STREQUAL "Android")
    set(GO_TARGET_OS "android")
elseif (CMAKE_SYSTEM_NAME STREQUAL "Windows")
    set(GO_TARGET_OS "windows")
elseif (CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
    set(GO_TARGET_OS "freebsd")
elseif (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
    set(GO_TARGET_OS "darwin")
else ()
    message(FATAL_ERROR "Unable to auto-determine GOOS. Please set GO_TARGET_OS_OVERRIDE manually.")
endif ()
message(STATUS "Using GOOS=${GO_TARGET_OS} and GOARCH=${GO_TARGET_ARCH}")

# define default GOFLAGS
string(TOUPPER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_UPPER)
set(GO_FLAGS_OVERRIDE
    ""
    CACHE STRING "overrides the 'GOFLAGS' variable")
if (GO_FLAGS_OVERRIDE)
    set(GO_FLAGS "${GO_FLAGS_OVERRIDE}")
else ()
    set(GO_FLAGS "-trimpath -mod=readonly -modcacherw")
endif ()
foreach (LANGUAGE C CXX)
    set(CGO_${LANGUAGE}FLAGS_OVERRIDE
        ""
        CACHE STRING "overrides the 'CGO_${LANGUAGE}FLAGS' variable")
    if (CGO_${LANGUAGE}FLAGS_OVERRIDE)
        set(CGO_${LANGUAGE}FLAGS "${CGO_${LANGUAGE}FLAGS_OVERRIDE}")
    else ()
        set(CGO_${LANGUAGE}FLAGS "${CMAKE_${LANGUAGE}_FLAGS_INIT} ${CMAKE_${LANGUAGE}_FLAGS_${CMAKE_BUILD_TYPE_UPPER}_INIT}")
        if (CMAKE_${LANGUAGE}_COMPILER_TARGET)
            set(CGO_${LANGUAGE}FLAGS "--target=${CMAKE_${LANGUAGE}_COMPILER_TARGET} ${CGO_${LANGUAGE}FLAGS}")
        endif ()
    endif ()
endforeach ()
set(CGO_LDFLAGS_OVERRIDE
    ""
    CACHE STRING "overrides the 'CGO_LDFLAGS' variable")
if (CGO_LDFLAGS_OVERRIDE)
    set(CGO_LDFLAGS "${CGO_LDFLAGS_OVERRIDE}")
else ()
    set(CGO_LDFLAGS "${CMAKE_SHARED_LINKER_FLAGS_INIT} ${CMAKE_SHARED_LINKER_FLAGS_${CMAKE_BUILD_TYPE_UPPER}_INIT}")
    if (CMAKE_C_COMPILER_TARGET)
        set(CGO_LDFLAGS "--target=${CMAKE_C_COMPILER_TARGET} ${CGO_LDFLAGS}")
    endif ()
endif ()

# enforce defaults for cgo build when using MSVC as cgo doesn't seem to support it
if (MSVC)
    unset(GO_COMPILER_ARGS)
    unset(GO_RANLIB_ARGS)
    unset(CGO_CFLAGS)
    unset(CGO_CXXFLAGS)
    unset(CGO_LDFLAGS)
endif ()

# locate the Syncthing checkout
set(GO_DEVELOPMENT_PATH
    "${CMAKE_CURRENT_SOURCE_DIR}/go"
    CACHE PATH "the 'GOPATH'")
set(SYNCTHING_PATH
    "${CMAKE_CURRENT_SOURCE_DIR}/go/src/github.com/syncthing/syncthing"
    CACHE PATH "path of Syncthing checkout")

# find Syncthing's assets (caveat: newly added assets will not cause CMake to automatically regenerate)
file(
    GLOB_RECURSE SRC_FILES_SYNCTHING_ASSETS
    LIST_DIRECTORIES false
    RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}"
    "${SYNCTHING_PATH}/gui/*")
if (NOT SRC_FILES_SYNCTHING_ASSETS)
    message(FATAL_ERROR "No asset files found in Syncthing checkout \"${SYNCTHING_PATH}\".")
endif ()

# find Syncthing's source code (caveat: newly added files will not cause CMake to automatically regenerate)
file(
    GLOB_RECURSE SRC_FILES_SYNCTHING
    LIST_DIRECTORIES false
    RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}"
    "${SYNCTHING_PATH}/c-bindings/*.go"
    "${SYNCTHING_PATH}/c-bindings/*.h"
    "${SYNCTHING_PATH}/c-bindings/*.c"
    "${SYNCTHING_PATH}/cmd/syncthing/*.go"
    "${SYNCTHING_PATH}/lib/*.go"
    "${SYNCTHING_PATH}/lib/*.h"
    "${SYNCTHING_PATH}/lib/*.c")
if (NOT SRC_FILES_SYNCTHING)
    message(FATAL_ERROR "No *.go files found in Syncthing checkout \"${SYNCTHING_PATH}\".")
endif ()
set(GENERATED_SYNCTHING_GUI_FILES_RELATIVE_PATH "lib/api/auto/gui.files.go")
list(APPEND SRC_FILES_SYNCTHING "${SYNCTHING_PATH}/${GENERATED_SYNCTHING_GUI_FILES_RELATIVE_PATH}")
message(STATUS "Syncthing's source files: ${SRC_FILES_SYNCTHING}")

# set Go linker flags
set(GO_LINKER_FLAGS_OVERRIDE
    ""
    CACHE STRING "overrides flags passed to Go's build system via -ldflags")
set(GO_LINKER_FLAGS "${GO_LINKER_FLAGS_OVERRIDE}")
if (CMAKE_BUILD_TYPE STREQUAL Release OR CMAKE_BUILD_TYPE STREQUAL MinSizeRel)
    set(GO_LINKER_FLAGS "${GO_LINKER_FLAGS} -w")
endif ()
if (META_SYNCTHING_VERSION)
    set(GO_LINKER_FLAGS "${GO_LINKER_FLAGS} -X github.com/syncthing/syncthing/lib/build.Version=${META_SYNCTHING_VERSION}")
endif ()
if (DEFINED $ENV{USER})
    set(GO_LINKER_FLAGS "${GO_LINKER_FLAGS} -X github.com/syncthing/syncthing/lib/build.User=$ENV{USER}")
endif ()
if (DEFINED $ENV{BUILD_HOST})
    set(BUILD_HOST $ENV{BUILD_HOST})
else ()
    cmake_host_system_information(RESULT BUILD_HOST QUERY HOSTNAME)
endif ()
if (BUILD_HOST)
    set(GO_LINKER_FLAGS "${GO_LINKER_FLAGS} -X github.com/syncthing/syncthing/lib/build.Host=${BUILD_HOST}")
endif ()
if (DEFINED $ENV{BUILD_STAMP})
    set(BUILD_STAMP "$ENV{BUILD_STAMP}")
else ()
    string(TIMESTAMP BUILD_STAMP "%s" UTC)
endif ()
set(GO_LINKER_FLAGS "${GO_LINKER_FLAGS} -X github.com/syncthing/syncthing/lib/build.Stamp=${BUILD_STAMP}")

# set Go build arguments
set(GO_BUILD_MOD
    ""
    CACHE STRING "sets the Go module download mode")
set(GO_BUILD_MODFILE
    ""
    CACHE STRING "sets an alternative go.mod file for the Go build")
set(GO_BUILD_EXTRA_ARGS
    ""
    CACHE STRING "additional arguments to add to the Go build (see `go help build`)")
unset(GO_BUILD_ARGS)
if (GO_BUILD_MOD)
    list(APPEND GO_BUILD_ARGS -mod "${GO_BUILD_MOD}")
endif ()
if (GO_BUILD_MODFILE)
    list(APPEND GO_BUILD_ARGS -modfile "${GO_BUILD_MODFILE}")
endif ()
list(APPEND GO_BUILD_ARGS -v)
if (GO_TARGET_OS STREQUAL "android")
    # use buildmode c-shared on Android because c-archive is not supported, see https://github.com/golang/go/issues/33806
    set(SYNCTHINGINTERNAL_LIBRARY_TYPE SHARED)
    set(SYNCTHINGINTERNAL_LIBRARY_NAME "libsyncthinginternal.so")
    list(APPEND GO_BUILD_ARGS -buildmode c-shared)
    set(GO_RANLIB_ARGS "")
else ()
    set(SYNCTHINGINTERNAL_LIBRARY_TYPE STATIC)
    set(SYNCTHINGINTERNAL_LIBRARY_NAME "libsyncthinginternal.a")
    list(APPEND GO_BUILD_ARGS -buildmode c-archive)
endif ()
if (GO_BUILD_EXTRA_ARGS)
    list(APPEND GO_BUILD_ARGS "${GO_BUILD_EXTRA_ARGS}")
endif ()

# define paths where the library and header generated by cgo are supposed to go
set(SYNCTHINGINTERNAL_HEADER_PATH "${CMAKE_CURRENT_BINARY_DIR}/libsyncthinginternal.h")
set(SYNCTHINGINTERNAL_LIBRARY_PATH "${CMAKE_CURRENT_BINARY_DIR}/${SYNCTHINGINTERNAL_LIBRARY_NAME}")

# generate Syncthing's assets (not setting GOARCH/GOOS here, this is supposed to run on the host)
add_custom_command(
    OUTPUT "${SYNCTHING_PATH}/${GENERATED_SYNCTHING_GUI_FILES_RELATIVE_PATH}"
    COMMAND "${CMAKE_COMMAND}" -E env "GO111MODULE=on" "GOPATH=${GO_DEVELOPMENT_PATH}" "GOFLAGS=${GO_FLAGS}" "${GO_BIN}" run
            ./script/genassets.go gui > "${GENERATED_SYNCTHING_GUI_FILES_RELATIVE_PATH}"
    DEPENDS ${SRC_FILES_SYNCTHING_ASSETS}
    WORKING_DIRECTORY "${SYNCTHING_PATH}"
    COMMENT "Building Syncthing's assets")

# compile Syncthing as static library
add_custom_command(
    OUTPUT "${SYNCTHINGINTERNAL_LIBRARY_PATH}" "${SYNCTHINGINTERNAL_HEADER_PATH}"
    COMMAND
        "${CMAKE_COMMAND}" -E env ${GO_COMPILER_ARGS} "GOOS=${GO_TARGET_OS}" "CGO_CFLAGS=${CGO_CFLAGS}"
        "CGO_CXXFLAGS=${CGO_CXXFLAGS}" "CGO_LDFLAGS=${CGO_LDFLAGS}" "GOARCH=${GO_TARGET_ARCH}" "CGO_ENABLED=1"
        "GO111MODULE=on" "GOPATH=${GO_DEVELOPMENT_PATH}" "GOFLAGS=${GO_FLAGS}" "${GO_BIN}" build ${GO_BUILD_ARGS} -o
        "${SYNCTHINGINTERNAL_LIBRARY_PATH}" -ldflags "${GO_LINKER_FLAGS}" ./c-bindings ${GO_RANLIB_ARGS}
    DEPENDS ${SRC_FILES_SYNCTHING}
    WORKING_DIRECTORY "${SYNCTHING_PATH}"
    COMMENT "Building Syncthing itself (as library)")

# allow running Syncthing's tests via CTest
add_test(
    NAME "${META_PROJECT_NAME}_run_go_tests"
    COMMAND
        "${CMAKE_COMMAND}" -E env ${GO_COMPILER_ARGS} "GOOS=${GO_TARGET_OS}" "CGO_CFLAGS=${CGO_CFLAGS}"
        "CGO_CXXFLAGS=${CGO_CXXFLAGS}" "CGO_LDFLAGS=${CGO_LDFLAGS}" "GOARCH=${GO_TARGET_ARCH}" "CGO_ENABLED=1"
        "GO111MODULE=on" "GOPATH=${GO_DEVELOPMENT_PATH}" "GOFLAGS=${GO_FLAGS}" "${GO_BIN}" test -skip
        "TestResolveWindows83|TestCheckGoFmt" -ldflags "${GO_LINKER_FLAGS}" ./lib/... ./cmd/syncthing/... ./c-bindings/...
    WORKING_DIRECTORY "${SYNCTHING_PATH}")

# find c++utilities to use CMake modules and headers from it privately
find_package(${PACKAGE_NAMESPACE_PREFIX}c++utilities${CONFIGURATION_PACKAGE_SUFFIX} 5.0.0 REQUIRED)
list(APPEND CMAKE_MODULE_PATH ${CPP_UTILITIES_MODULE_DIRS})
if (CPP_UTILITIES_SOURCE_DIR)
    list(APPEND PRIVATE_INCLUDE_DIRS $<BUILD_INTERFACE:${CPP_UTILITIES_SOURCE_DIR}/..>
         $<INSTALL_INTERFACE:${CPP_UTILITIES_INCLUDE_DIRS}>)
else ()
    list(APPEND PRIVATE_INCLUDE_DIRS ${CPP_UTILITIES_INCLUDE_DIRS})
endif ()

# apply basic config
include(BasicConfig)

# add imported target for library generated by the Go build system
add_library(syncthinginternal ${SYNCTHINGINTERNAL_LIBRARY_TYPE} IMPORTED)
get_filename_component(SYNCTHINGINTERNAL_LIBRARY_PATH_ABSOLUTE "${SYNCTHINGINTERNAL_LIBRARY_PATH}" ABSOLUTE)
set(SYNCTHINGINTERNAL_LIBRARY_PATH
    "${SYNCTHINGINTERNAL_LIBRARY_PATH_ABSOLUTE}"
    PARENT_SCOPE)
set_property(TARGET syncthinginternal PROPERTY IMPORTED_LOCATION "${SYNCTHINGINTERNAL_LIBRARY_PATH}")
set_property(TARGET syncthinginternal PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${SYNCTHING_PATH}/c-bindings")

# add additional libraries (not sure if go build could provide this list somehow to make this more generic)
if (SYNCTHINGINTERNAL_LIBRARY_TYPE STREQUAL STATIC)
    if (WIN32)
        set(SYNCTHING_INTERNAL_LIBS ws2_32 winmm)
    elseif (UNIX)
        set_property(
            TARGET syncthinginternal
            APPEND
            PROPERTY INTERFACE_LINK_OPTIONS "-pthread")
    endif ()
    foreach (LIBRARY ${SYNCTHING_INTERNAL_LIBS})
        find_library(SYNCTHING_INTERNAL_LIBRARY_PATH_${LIBRARY} ${LIBRARY})

=== syncthingconnector/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17.0 FATAL_ERROR)

# metadata
set(META_PROJECT_NAME syncthingconnector)
set(META_PROJECT_TYPE library)
set(META_APP_NAME "Connection backend of Syncthing Tray")
set(META_APP_DESCRIPTION "Connection backend of Syncthing Tray")
set(META_PROJECT_VARNAME_UPPER LIB_SYNCTHING_CONNECTOR)
set(META_PUBLIC_QT_MODULES Core Network)

# add project files
set(HEADER_FILES
    syncthingcompletion.h
    syncthingdir.h
    syncthingdev.h
    syncthingconnection.h
    syncthingconnectionenums.h
    syncthingconnectionstatus.h
    syncthingconnectionsettings.h
    syncthingnotifier.h
    syncthingconfig.h
    syncthingignorepattern.h
    syncthingprocess.h
    syncthingservice.h
    qstringhash.h
    utils.h)
set(SRC_FILES
    syncthingdir.cpp
    syncthingdev.cpp
    syncthingconnection.cpp
    syncthingconnection_requests.cpp
    syncthingconnectionsettings.cpp
    syncthingnotifier.cpp
    syncthingconfig.cpp
    syncthingignorepattern.cpp
    syncthingprocess.cpp
    syncthingservice.cpp
    utils.cpp)

set(TEST_HEADER_FILES)
set(TEST_SRC_FILES tests/connectiontests.cpp tests/patterntests.cpp tests/misctests.cpp)

set(TS_FILES translations/${META_PROJECT_NAME}_zh_CN.ts translations/${META_PROJECT_NAME}_cs_CZ.ts
             translations/${META_PROJECT_NAME}_de_DE.ts translations/${META_PROJECT_NAME}_en_US.ts)

# find c++utilities
find_package(${PACKAGE_NAMESPACE_PREFIX}c++utilities${CONFIGURATION_PACKAGE_SUFFIX} 5.27.0 REQUIRED)
use_cpp_utilities(VISIBILITY PUBLIC)
list(APPEND META_PUBLIC_COMPILE_DEFINITIONS CPP_UTILITIES_FLAG_ENUM_CLASS_NO_LEGACY_AND)

# find qtutilities (only headers and CMake modules used)
find_package(${PACKAGE_NAMESPACE_PREFIX}qtutilities${CONFIGURATION_PACKAGE_SUFFIX_QTUTILITIES} 6.3.0 REQUIRED)
use_qt_utilities(ONLY_HEADERS VISIBILITY PUBLIC)

# find boost libraries
include(3rdParty)
option(USE_BOOST_PROCESS "enables Boost.Process for improved behavior of the launcher" ON)
if (USE_BOOST_PROCESS)
    option(BOOST_STATIC_LINKAGE "${STATIC_LINKAGE}" "link statically against Boost (instead of dynamically)")
    set(Boost_USE_MULTITHREADED ON)
    if (BOOST_STATIC_LINKAGE)
        set(Boost_USE_STATIC_LIBS ON)
    endif ()
    # add Boost::boost target which represents include directory for header-only deps and add Boost::filesystem as it is
    # needed by Boost.Process
    set(BOOST_ARGS 1.75 REQUIRED) # 1.66 does not invoke on_exit handler correctly, 1.75 was the next version I tested and it
                                  # worked
    list(APPEND BOOST_ARGS COMPONENTS filesystem)
    use_package(TARGET_NAME Boost::boost PACKAGE_NAME Boost PACKAGE_ARGS "${BOOST_ARGS}")
    use_package(TARGET_NAME Boost::filesystem PACKAGE_NAME Boost PACKAGE_ARGS "${BOOST_ARGS}")
    list(APPEND META_PUBLIC_COMPILE_DEFINITIONS ${META_PROJECT_VARNAME_UPPER}_BOOST_PROCESS)
    if (WIN32)
        list(APPEND PRIVATE_LIBRARIES ws2_32) # needed by Boost.Asio
    endif ()
    if (MINGW)
        # workaround https://github.com/boostorg/process/issues/96
        set_property(
            SOURCE syncthingprocess.cpp
            APPEND
            PROPERTY COMPILE_DEFINITIONS BOOST_USE_WINDOWS_H WIN32_LEAN_AND_MEAN)
    elseif (MSVC)
        # prevent "Please define _WIN32_WINNT or _WIN32_WINDOWS appropriately."
        set_property(
            SOURCE syncthingprocess.cpp
            APPEND
            PROPERTY COMPILE_DEFINITIONS _WIN32_WINNT=0x0601)
    endif ()
    # add threading library as it is needed by Boost.Process
    use_package(TARGET_NAME Threads::Threads PACKAGE_NAME Threads PACKAGE_ARGS REQUIRED)
endif ()

# link also explicitly against the following Qt modules
list(APPEND ADDITIONAL_QT_MODULES Network)

# configure support for controlling Syncthing via systemd service
if (UNIX
    AND NOT APPLE
    AND NOT ANDROID)
    set(ENABLE_SYSTEMD_SUPPORT_BY_DEFAULT ON)
else ()
    set(ENABLE_SYSTEMD_SUPPORT_BY_DEFAULT OFF)
endif ()
option(SYSTEMD_SUPPORT "enables support for controlling Syncthing systemd service" ${ENABLE_SYSTEMD_SUPPORT_BY_DEFAULT})
if (SYSTEMD_SUPPORT)
    list(
        APPEND
        DBUS_FILES
        org.freedesktop.DBus.Properties.xml
        org.freedesktop.login1.LoginManager.xml
        org.freedesktop.systemd1.Manager.xml
        org.freedesktop.systemd1.Service.xml
        org.freedesktop.systemd1.Unit.xml)
    set_source_files_properties(org.freedesktop.systemd1.Manager.xml PROPERTIES INCLUDE syncthingservice.h)
    list(APPEND META_PUBLIC_COMPILE_DEFINITIONS ${META_PROJECT_VARNAME_UPPER}_SUPPORT_SYSTEMD)
    message(STATUS "systemd support enabled")
else ()
    message(STATUS "systemd support disabled")
endif ()

# configure whether the SyncthingConnection class should be mocked for test purposes
option(SYNCTHING_CONNECTION_MOCKED
       "enables mocking the SyncthingConnection class so it will provide only some fixed test data" OFF)
if (SYNCTHING_CONNECTION_MOCKED)
    list(APPEND SRC_FILES syncthingconnectionmockhelpers.h syncthingconnectionmockhelpers.cpp)
    set_property(
        SOURCE syncthingconnection.cpp syncthingconnection_requests.cpp syncthingconnectionmockhelpers.h
               syncthingconnectionmockhelpers.cpp
        APPEND
        PROPERTY COMPILE_DEFINITIONS ${META_PROJECT_VARNAME_UPPER}_CONNECTION_MOCKED)
    message(WARNING "SyncthingConnection class will be mocked")
endif ()

# configure whether the SyncthingService class should be mocked for test purposes
option(SYNCTHING_SERVICE_MOCKED "enables mocking the SyncthingService class so it will provide some fake status" OFF)
if (SYNCTHING_SERVICE_MOCKED)
    set_property(
        SOURCE syncthingservice.cpp
        APPEND
        PROPERTY COMPILE_DEFINITIONS ${META_PROJECT_VARNAME_UPPER}_SERVICE_MOCKED)
    message(WARNING "SyncthingService class will be mocked")
endif ()

# configure whether the SyncthingProcess class is supported
option(PROCESS_SUPPORT "enables support for process handling via the SyncthingProcess class" ON)
if (NOT PROCESS_SUPPORT)
    list(APPEND META_PUBLIC_COMPILE_DEFINITIONS ${META_PROJECT_VARNAME_UPPER}_NO_PROCESS)
endif ()

# include modules to apply configuration
include(BasicConfig)
include(QtConfig)
include(WindowsResources)
include(LibraryTarget)

# link tests against test helper (can't use find_package because testhelper target is not present at this point)
list(APPEND TEST_LIBRARIES syncthingtesthelper)
list(APPEND PRIVATE_INCLUDE_DIRS "${CMAKE_CURRENT_BINARY_DIR}/../testhelper/include")
include(TestTarget)

# avoid running this test in parallel with other tests spawning a Syncthing test instance
if (META_MAIN_TEST_NAME)
    set_tests_properties("${META_MAIN_TEST_NAME}" PROPERTIES RESOURCE_LOCK "syncthingtestinstance")
endif ()

# add additional library with mocked SyncthingConnector class so models can be tested without running Syncthing itself
if (EXCLUDE_TESTS_FROM_ALL)
    set(TESTS_EXCLUSION EXCLUDE_FROM_ALL)
else ()
    unset(TESTS_EXCLUSION)
endif ()
add_library(
    ${META_TARGET_NAME}_mocked
    ${TESTS_EXCLUSION}
    OBJECT
    syncthingconnection.h
    syncthingconnection.cpp
    syncthingconnection_requests.cpp
    syncthingconnectionmockhelpers.h
    syncthingconnectionmockhelpers.cpp)
target_link_libraries(
    ${META_TARGET_NAME}_mocked
    PUBLIC ${META_ADDITIONAL_LINK_FLAGS} "${PUBLIC_LIBRARIES}"
    PRIVATE "${PRIVATE_LIBRARIES}")
target_include_directories(
    ${META_TARGET_NAME}_mocked
    PUBLIC ${TARGET_INCLUDE_DIRECTORY_BUILD_INTERFACE} ${TARGET_GENERATED_INCLUDE_DIRECTORY} ${PUBLIC_INCLUDE_DIRS}
    PRIVATE ${PRIVATE_INCLUDE_DIRS})
target_compile_definitions(
    ${META_TARGET_NAME}_mocked
    PUBLIC ${META_PUBLIC_COMPILE_DEFINITIONS} ${META_PROJECT_VARNAME_UPPER}_MOCKED
           SyncthingConnection=SyncthingConnectionMocked
    PRIVATE ${META_PRIVATE_COMPILE_DEFINITIONS} MockedReply=MockedReplyTestLib)
target_compile_options(
    ${META_TARGET_NAME}_mocked
    PUBLIC "${META_PUBLIC_COMPILE_OPTIONS}"
    PRIVATE "${META_PRIVATE_COMPILE_OPTIONS}")
set_target_properties(${META_TARGET_NAME}_mocked PROPERTIES CXX_STANDARD "${META_CXX_STANDARD}")

include(Doxygen)
include(ConfigHeader)

=== testhelper/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17.0 FATAL_ERROR)

# metadata
set(META_PROJECT_NAME syncthingtesthelper)
set(META_PROJECT_TYPE library)
set(META_APP_NAME "Syncthing Tray Test Helper")
set(META_APP_DESCRIPTION "Helper for testing components of Syncthing Tray")
set(META_PUBLIC_QT_MODULES Core)
set(META_NO_INSTALL_TARGETS ON)
set(META_NO_CPP_UNIT ON)
set(META_TEST_TARGET_IS_MANUAL ON)
set(META_ADD_DEFAULT_CPP_UNIT_TEST_APPLICATION OFF)

# use testfiles directory from syncthingconnector
set(META_SRCDIR_REFS "${CMAKE_CURRENT_SOURCE_DIR}\n${CMAKE_CURRENT_SOURCE_DIR}/../syncthingconnector")

# add project files
set(HEADER_FILES helper.h syncthingtestinstance.h)
set(SRC_FILES helper.cpp syncthingtestinstance.cpp)

set(TEST_HEADER_FILES)
set(TEST_SRC_FILES tests/manualtesting.cpp)

set(TS_FILES)

# don't allow adding a target suffix to the test library
set(SYNCTHINGTESTHELPER_CONFIGURATION_TARGET_SUFFIX none)

# find c++utilities
find_package(${PACKAGE_NAMESPACE_PREFIX}c++utilities${CONFIGURATION_PACKAGE_SUFFIX} 5.0.0 REQUIRED)
use_cpp_utilities()

# find qtutilities (only CMake modules used)
find_package(${PACKAGE_NAMESPACE_PREFIX}qtutilities${CONFIGURATION_PACKAGE_SUFFIX_QTUTILITIES} 6.0.0 REQUIRED)
list(APPEND CMAKE_MODULE_PATH ${QT_UTILITIES_MODULE_DIRS})

# find syncthingconnector
find_package(syncthingconnector ${META_APP_VERSION} REQUIRED)
use_syncthingconnector()

# link also explicitly against the following Qt modules
list(APPEND ADDITIONAL_QT_MODULES Network)

# include modules to apply configuration
include(BasicConfig)
include(QtConfig)
include(WindowsResources)
include(LibraryTarget)
include(TestTarget)
include(Doxygen)
include(ConfigHeader)

# exclude the target from 'all' target so it is only built when tests are built
set_target_properties("${META_TARGET_NAME}" PROPERTIES EXCLUDE_FROM_ALL ON)

# avoid running this test in parallel with other tests spawning a Syncthing test instance
if (META_MAIN_TEST_NAME)
    set_tests_properties("${META_MAIN_TEST_NAME}" PROPERTIES RESOURCE_LOCK "syncthingtestinstance")
endif ()

=== tray/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17.0 FATAL_ERROR)

# metadata
set(META_PROJECT_TYPE application)
set(META_APP_NAME "Syncthing Tray")
set(META_APP_NAME_QUICK_GUI "Syncthing App")
set(META_GUI_OPTIONAL ON)
set(META_USE_QQC2 ON)
if (QUICK_GUI)
    set(META_QT_VERSION 6.8.0)
endif ()

# use testfiles directory from syncthingconnector
set(META_SRCDIR_REFS "${CMAKE_CURRENT_SOURCE_DIR}\n${CMAKE_CURRENT_SOURCE_DIR}/../syncthingconnector")

# add project files
set(HEADER_FILES)
set(SRC_FILES application/main.cpp)
set(WIDGETS_HEADER_FILES
    application/singleinstance.h
    gui/trayicon.h
    gui/traywidget.h
    gui/traymenu.h
    gui/dirbuttonsitemdelegate.h
    gui/devbuttonsitemdelegate.h
    gui/downloaditemdelegate.h
    gui/dirview.h
    gui/devview.h
    gui/downloadview.h
    gui/helper.h)
set(WIDGETS_SRC_FILES
    application/singleinstance.cpp
    gui/trayicon.cpp
    gui/traywidget.cpp
    gui/traymenu.cpp
    gui/dirbuttonsitemdelegate.cpp
    gui/devbuttonsitemdelegate.cpp
    gui/downloaditemdelegate.cpp
    gui/dirview.cpp
    gui/devview.cpp
    gui/downloadview.cpp
    gui/helper.cpp)
set(RES_FILES resources/${META_PROJECT_NAME}icons.qrc)
set(WIDGETS_UI_FILES gui/traywidget.ui)
set(QML_HEADER_FILES gui/quick/app.h gui/quick/scenegraph/managedtexturenode.h)
set(QML_SRC_FILES gui/quick/app.cpp gui/quick/scenegraph/managedtexturenode.cpp)

set(TS_FILES translations/${META_PROJECT_NAME}_zh_CN.ts translations/${META_PROJECT_NAME}_cs_CZ.ts
             translations/${META_PROJECT_NAME}_de_DE.ts translations/${META_PROJECT_NAME}_en_US.ts)

set(ICON_FILES resources/icons/hicolor/scalable/apps/${META_PROJECT_NAME}.svg)

set(DOC_FILES README.md)

# declare required icons; used when bundling icon themes (Icons required by libraries the tray application depends on need to
# be specified as well.)
set(REQUIRED_ICONS
    color-profile
    dialog-cancel
    dialog-ok
    dialog-ok-apply
    document-edit
    document-open
    document-open-remote
    download
    edit-copy
    edit-clear
    edit-cut
    edit-delete
    edit-paste
    edit-redo
    edit-select
    edit-undo
    emblem-checked
    emblem-error
    emblem-remove
    emblem-warning
    folder
    folder-download
    folder-open
    folder-sync
    go-down
    go-up
    help-about
    help-contents
    internet-web-browser
    list-add
    list-remove
    media-playback-pause
    media-playback-start
    network-connect
    network-disconnect
    network-server
    preferences-desktop
    preferences-desktop-icons
    preferences-desktop-locale
    preferences-desktop-notification
    preferences-system-startup
    preferences-system-startup
    preferences-system-services
    preferences-other
    process-stop
    question
    qtcreator
    system-run
    system-search
    system-file-manager
    text-x-generic
    quickwizard
    view-refresh
    window-close
    window-pin)

# configure use of C++ 20 in Android-specific code
if (ANDROID)
    set(META_CXX_STANDARD 20)
endif ()

# find c++utilities
find_package(${PACKAGE_NAMESPACE_PREFIX}c++utilities${CONFIGURATION_PACKAGE_SUFFIX} 5.28.0 REQUIRED)
use_cpp_utilities()

# find qtutilities
find_package(${PACKAGE_NAMESPACE_PREFIX}qtutilities${CONFIGURATION_PACKAGE_SUFFIX_QTUTILITIES} 6.15.0 REQUIRED)
use_qt_utilities()

# find backend libraries
find_package(syncthingconnector ${META_APP_VERSION} REQUIRED)
use_syncthingconnector()
find_package(syncthingmodel ${META_APP_VERSION} REQUIRED)
use_syncthingmodel()
find_package(syncthingwidgets ${META_APP_VERSION} REQUIRED)
use_syncthingwidgets()

# link against the qtforkawesomeiconengine plugin when it is a static library
include(3rdParty)
find_package(${PACKAGE_NAMESPACE_PREFIX}qtforkawesomeiconengine${CONFIGURATION_PACKAGE_SUFFIX_QTFORKAWESOME} 0.1.0 REQUIRED)
if (NOT QT_FORK_AWESOME_ICON_ENGINE_LIB_IS_SHARED)
    use_qt_fork_awesome_icon_engine()
endif ()

# link also explicitly against the following Qt modules
list(APPEND ADDITIONAL_QT_MODULES Network)

# configure libsyncthing
option(USE_LIBSYNCTHING "whether libsyncthing should be included for syncthingtray's CLI" OFF)
if (USE_LIBSYNCTHING)
    find_package(syncthing ${META_APP_VERSION} REQUIRED)
    use_syncthing()
    list(APPEND META_PUBLIC_COMPILE_DEFINITIONS SYNCTHINGTRAY_USE_LIBSYNCTHING)
endif ()

# apply basic configuration
include(BasicConfig)

if (QUICK_GUI)
    find_package(${PACKAGE_NAMESPACE_PREFIX}qtquickforkawesome${CONFIGURATION_PACKAGE_SUFFIX_QTFORKAWESOME} 0.1.0 REQUIRED)
    use_qt_quick_fork_awesome()
endif ()

# add an option to unify left- and right-click context menus useful on Mac OS
if (APPLE)
    set(UNIFY_TRAY_MENUS_BY_DEFAULT ON)
else ()
    set(UNIFY_TRAY_MENUS_BY_DEFAULT OFF)
endif ()
option(UNIFY_TRAY_MENUS "unifies the left- and right-click tray menus" ${UNIFY_TRAY_MENUS_BY_DEFAULT})
if (UNIFY_TRAY_MENUS)
    list(APPEND META_PUBLIC_COMPILE_DEFINITIONS ${META_PROJECT_VARNAME_UPPER}_UNIFY_TRAY_MENUS)
    message(STATUS "left- and right-click context menus will be unified")
endif ()

# link against library to use Android's Bitmap API (see https://developer.android.com/ndk/reference/group/bitmap)
if (ANDROID)
    find_library(JNI_GRAPHICS_LIB jnigraphics REQUIRED)
    list(APPEND PRIVATE_LIBRARIES ${JNI_GRAPHICS_LIB})
endif ()

# add shortcuts/actions to desktop file
set(ACTIONS
    "Actions=ShowTrayMenu;ShowSyncthing;RescanAll;PauseAllDevs;ResumeAllDevs;Restart\n\n\
[Desktop Action ShowTrayMenu]\n\
Name=Show tray menu\n\
Exec=${META_TARGET_NAME} qt-widgets-gui --trigger\n\
[Desktop Action ShowSyncthing]\n\
Name=Show Syncthing (currently selected instance)\n\
Exec=${META_TARGET_NAME} qt-widgets-gui --webui\n\
[Desktop Action RescanAll]\n\
Name=Rescan all folders (of local Syncthing instance)\n\
Exec=${SYNCTHINGCTL_TARGET_NAME} rescan-all\n\
[Desktop Action PauseAllDevs]\n\
Name=Pause all devices (of local Syncthing instance)\n\
Exec=${SYNCTHINGCTL_TARGET_NAME} pause --all-devs\n\
[Desktop Action ResumeAllDevs]\n\
Name=Resume all devices (of local Syncthing instance)\n\
Exec=${SYNCTHINGCTL_TARGET_NAME} resume --all-devs\n\
[Desktop Action Restart]\n\
Name=Restart Syncthing (local instance)\n\
Exec=${SYNCTHINGCTL_TARGET_NAME} restart")
set(DESKTOP_FILE_ADDITIONAL_ENTRIES "${DESKTOP_FILE_ADDITIONAL_ENTRIES}${ACTIONS}\n")

# configure Qt Quick GUI
include(QtGuiConfig)
if (QUICK_GUI)
    use_standard_filesystem()

    unset(ADDITIONAL_QML_FILES)
    list(APPEND ADDITIONAL_QT_MODULES Concurrent Svg)
    list(APPEND ADDITIONAL_QT_REPOS svg)
    list(APPEND PRIVATE_INCLUDE_DIRS gui/quick)

    # allow showing the web interface as page in the app (not used right now; hence disabled by default)
    option(QUICK_GUI_WEBVIEW_PAGE "disables web view support in the Qt Quick GUI" OFF)
    if (QUICK_GUI_WEBVIEW_PAGE)
        list(APPEND ADDITIONAL_QML_FILES gui/qml/WebViewPage.qml)
        include(QtLinkage)
        unset(WEBVIEWITEM_QML_FILES)
        # check whether Qt WebView is present
        option(QUICK_GUI_NO_WEBVIEW "disables web view support in the Qt Quick GUI" ON)
        if (NOT QUICK_GUI_NO_WEBVIEW)
            find_package("${QT_PACKAGE_PREFIX}WebView" "${META_QT_VERSION}")
            find_package("${QT_PACKAGE_PREFIX}WebViewQuick" "${META_QT_VERSION}")
            if ("${${QT_PACKAGE_PREFIX}WebView_FOUND}" AND "${${QT_PACKAGE_PREFIX}WebViewQuick_FOUND}")
                list(APPEND ADDITIONAL_QT_MODULES WebView WebViewQuick)
                list(APPEND ADDITIONAL_QT_REPOS webview)
                list(APPEND WEBVIEWITEM_QML_FILES gui/qml/webview-webview/WebViewItem.qml)
                set_property(
                    SOURCE application/main.cpp
                    APPEND
                    PROPERTY COMPILE_DEFINITIONS ${META_PROJECT_VARNAME_UPPER}_HAS_WEBVIEW)
            endif ()
        endif ()
        if (NOT WEBVIEWITEM_QML_FILES)
            list(APPEND WEBVIEWITEM_QML_FILES gui/qml/webview-none/WebViewItem.qml)
        endif ()
        set_property(
            SOURCE application/main.cpp
            APPEND
            PROPERTY COMPILE_DEFINITIONS ${META_PROJECT_VARNAME_UPPER}_HAS_WEBVIEW_PAGE)

        # find Qt Qml and enable automoc which is required for the subsequent qt_add_qml_module calls
        find_package("${QT_PACKAGE_PREFIX}Qml" "${META_QT_VERSION}")
        set(CMAKE_AUTOMOC ON)

        # add additional module for the web view
        qt_add_qml_module(
            ${META_TARGET_NAME}-webviewitem
            URI
            "WebViewItem"
            VERSION
            1.0
            STATIC
            QML_FILES
            ${WEBVIEWITEM_QML_FILES}
            RESOURCE_PREFIX
            "/qt/qml/"
            OUTPUT_DIRECTORY
            "${CMAKE_CURRENT_BINARY_DIR}/WebViewItem"
            NO_PLUGIN_OPTIONAL)
        list(APPEND PRIVATE_LIBRARIES ${META_TARGET_NAME}-webviewitemplugin)
    endif ()
endif ()

# include further modules to apply configuration
include(QtConfig)
include(WindowsResources)
include(AppTarget)
include(ShellCompletion)
include(Doxygen)
include(ConfigHeader)

# deduce major Qt version from package prefix
if (NOT QT_PACKAGE_PREFIX)
    set(MAJOR_QT_VERSION "5")
elseif (QT_PACKAGE_PREFIX MATCHES ".*Qt([0-9]+).*")
    set(MAJOR_QT_VERSION "${CMAKE_MATCH_1}")
endif ()

# require Qt 6 for the Qt Quick GUI
if (QUICK_GUI AND (MAJOR_QT_VERSION VERSION_LESS 6 OR MAJOR_QT_VERSION VERSION_GREATER_EQUAL 7))
    message(FATAL_ERROR "The Qt Quick GUI is only compatible with Qt 6 (but Qt ${MAJOR_QT_VERSION} was found).")
endif ()

# add Qml module
if (QUICK_GUI)
    qt_policy(SET QTP0004 NEW)
    qt_add_qml_module(
        ${META_TARGET_NAME}
        URI
        "Main"
        VERSION
        1.0
        NO_PLUGIN
        QML_FILES
        gui/qml/AboutDialog.qml
        gui/qml/AdvancedConfigPage.qml
        gui/qml/AdvancedDevConfigPage.qml
        gui/qml/AdvancedDirConfigPage.qml
        gui/qml/AdvancedPage.qml
        gui/qml/ArrayElementButtons.qml
        gui/qml/ChangesPage.qml
        gui/qml/CopyPasteButtons.qml
        gui/qml/CustomDialog.qml
        gui/qml/CustomFlickable.qml
        gui/qml/CustomListView.qml
        gui/qml/CustomToolButton.qml
        gui/qml/DetailsListView.qml
        gui/qml/DevConfigPage.qml
        gui/qml/DevDelegate.qml
        gui/qml/DevListView.qml
        gui/qml/DevsPage.qml
        gui/qml/DirConfigPage.qml
        gui/qml/DirDelegate.qml
        gui/qml/DirListView.qml
        gui/qml/DirErrorsPage.qml
        gui/qml/DirsPage.qml
        gui/qml/ErrorsDelegate.qml
        gui/qml/ErrorsPage.qml
        gui/qml/ExpandableDelegate.qml
        gui/qml/ExpandableItemDelegate.qml
        gui/qml/ExpandableListView.qml
        gui/qml/FilesPage.qml
        gui/qml/ForkAwesomeIcon.qml
        gui/qml/HelpButton.qml
        gui/qml/HomeDirPage.qml
        gui/qml/IconOnlyButton.qml
        gui/qml/IgnorePatternPage.qml
        gui/qml/ImportPage.qml
        gui/qml/InternalErrorsPage.qml
        gui/qml/LoadingPane.qml
        gui/qml/LogPage.qml
        gui/qml/Main.qml
        gui/qml/MainTabButton.qml
        gui/qml/MenuItemInstantiator.qml
        gui/qml/NeededPage.qml
        gui/qml/ObjectConfigDelegate.qml
        gui/qml/ObjectConfigPage.qml
        gui/qml/OutOfSyncDirs.qml
        gui/qml/PendingDevices.qml
        gui/qml/PendingDirs.qml
        gui/qml/StartPage.qml
        gui/qml/Statistics.qml
        gui/qml/StatisticsPage.qml
        gui/qml/SelectiveImportDelegate.qml
        gui/qml/SettingsPage.qml
        ${ADDITIONAL_QML_FILES}
        SOURCES
        gui/quick/quickicon.h
        gui/quick/quickicon.cpp
        RESOURCE_PREFIX
        "/qt/qml/")

    # workaround build errors due to implicit conversions in generated code
    if (TREAT_WARNINGS_AS_ERRORS)
        foreach (QML_FILE AdvancedDevConfigPage AdvancedDirConfigPage)
            set_source_files_properties(
                "${CMAKE_CURRENT_BINARY_DIR}/.rcc/qmlcache/${META_TARGET_NAME}_gui/qml/${QML_FILE}_qml.cpp"

=== plasmoid/lib/CMakeLists.txt ===
# source files
set(HEADER_FILES syncthingapplet.h settingsdialog.h)
set(SRC_FILES syncthingapplet.cpp settingsdialog.cpp)
set(WIDGETS_UI_FILES appearanceoptionpage.ui)
foreach (PLASMOID_FILE ${PLASMOID_FILES})
    list(APPEND QML_SRC_FILES "../${PLASMOID_FILE}")
endforeach ()
foreach (PLASMOID_FILE ${PLASMOID_EXCLUDED_FILES})
    list(APPEND EXCLUDED_FILES "../${PLASMOID_FILE}")
endforeach ()
set(TS_FILES ../translations/${META_PROJECT_NAME}_de_DE.ts ../translations/${META_PROJECT_NAME}_en_US.ts)

# find qtutilities
find_package(${PACKAGE_NAMESPACE_PREFIX}qtutilities${CONFIGURATION_PACKAGE_SUFFIX_QTUTILITIES} 6.13.0 REQUIRED)
use_qt_utilities()

# find qtforkawesomequickimageprovider
find_package(${PACKAGE_NAMESPACE_PREFIX}qtquickforkawesome${CONFIGURATION_PACKAGE_SUFFIX_QTFORKAWESOME} 0.0.3 REQUIRED)
use_qt_quick_fork_awesome()

# check whether qtutilities supports DBus notifications
get_target_property(QT_UTILITIES_COMPILE_DEFINITIONS ${QT_UTILITIES_LIB} INTERFACE_COMPILE_DEFINITIONS)
list(FIND QT_UTILITIES_COMPILE_DEFINITIONS QT_UTILITIES_SUPPORT_DBUS_NOTIFICATIONS QT_UTILITIES_SUPPORT_DBUS_NOTIFICATIONS)
if (QT_UTILITIES_SUPPORT_DBUS_NOTIFICATIONS LESS 0)
    message(
        FATAL_ERROR
            "The provided build of Qt Utilities does not support D-Bus notifications which is required for the Plasmoid.")
endif ()

# find backend libraries
find_package(syncthingconnector ${META_APP_VERSION} REQUIRED)
use_syncthingconnector()
find_package(syncthingmodel ${META_APP_VERSION} REQUIRED)
use_syncthingmodel()
find_package(syncthingwidgets ${META_APP_VERSION} REQUIRED)
use_syncthingwidgets()

# link also explicitly against the following Qt modules
include(3rdParty)
list(APPEND ADDITIONAL_QT_MODULES Network Qml)
if (KF_MAJOR_VERSION GREATER_EQUAL 6)
    set(Config_MODULE_TARGETS ${KF_PACKAGE_PREFIX}::ConfigCore)
    list(APPEND ADDITIONAL_KF_MODULES Config)
    use_package(TARGET_NAME Plasma::Plasma PACKAGE_NAME Plasma PACKAGE_ARGS REQUIRED)
else ()
    list(APPEND ADDITIONAL_KF_MODULES Plasma)
endif ()

include(BasicConfig)
include(QtGuiConfig)
include(QtConfig)
include(WindowsResources)
include(LibraryTarget)
include(ConfigHeader)
include(AppUtilities)

# export some variable for further use in the overall plasmoid build script
set(META_TARGET_NAME
    "${META_TARGET_NAME}"
    PARENT_SCOPE)
set(META_ID
    "martchus.${META_TARGET_NAME}"
    PARENT_SCOPE)
set(META_PROJECT_LICENSE
    "${META_PROJECT_LICENSE}"
    PARENT_SCOPE)

# convert meta-data file to JSON
if (KF_MAJOR_VERSION LESS 6)
    kcoreaddons_desktop_to_json("${META_TARGET_NAME}" "${PLASMOID_CONFIG_TARGET_FILE}" DESKTOP_TO_JSON_OUTPUT_DIR
                                "${PLASMOID_PACKAGE_DIR}")
endif ()

# set the library prefix so it doesn't start with "lib" and is rather prefixed with "martchus."
if (KF_MAJOR_VERSION GREATER_EQUAL 6)
    set_target_properties(${META_TARGET_NAME} PROPERTIES PREFIX "martchus.")
endif ()

# install appstream file
add_appstream_file()

=== debian/changelog ===
syncthingtray (1.7.5-1build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 11 Aug 2025 08:26:27 +0200

syncthingtray (1.7.5-1) unstable; urgency=medium

  * New upstream release.
  * Update Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Resolve lintian W: old-fsf-address-in-copyright-file by referring to
    GNU's website.

 -- Nicholas D Steeves <sten@debian.org>  Fri, 04 Apr 2025 21:56:09 -0400

=== debian/control ===
Source: syncthingtray
Section: net
Priority: optional
Maintainer: Nicholas D Steeves <sten@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               doxygen,
               extra-cmake-modules,
               libboost-dev,
               libboost-filesystem-dev,
               libcppunit-dev,
               libkf6kio-dev,
               libplasma-dev,
               libmartchus-c++utilities-dev (>= 5.28.0-1~),
               libmartchus-qtforkawesome-dev (>= 0.3.1-2~),
               libmartchus-qtutilities-dev (>= 6.15.0-1~),
               qt6-svg-dev,
               pkgconf,
               qt6-base-dev,
               qt6-declarative-dev,
               qt6-tools-dev,
               qt6-webengine-dev,
               ronn,
               syncthing
Rules-Requires-Root: no
Standards-Version: 4.7.2
Homepage: https://github.com/Martchus/syncthingtray
Vcs-Browser: https://salsa.debian.org/debian/syncthingtray
Vcs-Git: https://salsa.debian.org/debian/syncthingtray.git

Package: syncthingtray
Architecture: any
Multi-Arch: no
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: syncthing
Enhances: syncthing
Description: desktop integration for Syncthing
 Syncthing Tray is a user-friendly frontend for Syncthing.  The tray applet
 contains a dashboard and remote controls for Syncthing.
 .
 This package makes Syncthing easier to use because it provides desktop
 integration; The familiarity of a desktop interface makes it easier to
 add shared folders and remote nodes, as well as to associate them with
 each other.  It also provides quick access to the Device ID QR code so
 that phones can be more easily added to the mesh network.
 .
 Syncthing Tray is also typically used to enable, monitor, and control the
 Syncthing systemd service.  Finally, a program called "syncthingctl" is
 provided as an additional remote control; it may be useful in scripts.
 .
 Syncthing is an application for decentralised file synchronisation and p2p
 folder sharing.  It is an alternative solution to Dropbox, Google Drive,
 and WebDav.  Syncthing also fulfills (or exceeds) the requirements for
 file synchronisation that users of iCloud, ownCloud, or Nextcloud expect.
 .
 This package contains the tray applet, and syncthingctl.  Users of KDE
 Plasma will benefit from superior integration as well as addition features
 provided in the "syncthingtray-kde-plasma" package.

Package: syncthingtray-kde-plasma
Architecture: any
Multi-Arch: no
Depends: ${misc:Depends}, ${shlibs:Depends},
         syncthingtray (=${binary:Version})
Enhances: syncthing, dolphin, plasma-desktop
Description: KDE Plasma Desktop and Dolphin integration for Syncthing
 Syncthing Tray is a user-friendly frontend for Syncthing.
 .
 This package makes Syncthing easier to use because it provides desktop
 integration; The familiarity of a desktop interface makes it easier to
 add shared folders and remote nodes, as well as to associate them with
 each other.  It also provides quick access to the Device ID QR code so
 that phones can be more easily added to the mesh network.
 .
 Syncthing Tray is also typically used to enable, monitor, and control the
 Syncthing systemd service.  Finally, a program called "syncthingctl" is
 provided as an additional remote control; it may be useful in scripts.
 .
 Syncthing is an application for decentralised file synchronisation and p2p
 folder sharing.  It is an alternative solution to Dropbox, Google Drive,
 and WebDav.  Syncthing also fulfills (or exceeds) the requirements for
 file synchronisation that users of iCloud, ownCloud, or Nextcloud expect.
 .
 This package contains the plasmoid for the KDE Plasma Desktop as well as a
 KIO plugin.  The KIO plugin is typically appreciated for enabling Syncthing
 awareness in the Dolphin file manager, and the plasmoid provides superior
 integration with KDE Plasma when compared to the multidesktop tray applet.

# 2022-05-05
# The development package has been purposefully disabled, because it has
# dubious utility with such an unstable and effectively private API.  It will
# hopefully become advantageous to enable this package some day.
#
# Package: syncthingtray-dev
# Section: libdevel
# Architecture: any
# Multi-Arch: no
# Depends: ${misc:Depends},
# syncthingtray (=${binary:Version}),
# syncthingtray-kde-plasma (=${binary:Version})
# Description: desktop integration for Syncthing (development package)
#  Syncthing Tray is a user-friendly frontend for Syncthing.  The tray applet
#  contains a dashboard and remote controls for Syncthing.
#  .
#  This package makes Syncthing easier to use because it provides desktop
#  integration, and the familiarity of a desktop interface makes it easier to
#  add shared folders and remote nodes, as well as to associate them with each
#  other.  It also provides quick access to the Device ID QR code so that
#  phones can be more easily added to the mesh network.
#  .
#  Syncthing Tray is also typically used to enable, monitor, and control the
#  Syncthing systemd service.  Finally, a program called "syncthingctl" is
#  provided as an additional remote control; this program may of course be used
#  in scripts.
#  .
#  Syncthing is an application for decentralised file synchronisation and p2p
#  folder sharing.  It is an alternative solution to Dropbox, Google Drive,
#  and WebDav.  Syncthing also fulfills (or exceeds) the requirements for
#  file synchronisation that users of iCloud, ownCloud, or Nextcloud expect.
#  .
#  This package contains development headers, pkgconfig, and CMake components;
#  It is only required should one intend to develop programs that use
#  syncthingtray's libraries (libsyncthingconnector, libsyncthingmodel, and
#  libsyncthingwidgets).  Please note that at this time there is no stable ABI.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
BUILD_DIR=debian/build
DH_FLAGS=--builddirectory=$(BUILD_DIR)

%:
	dh $@ $(DH_FLAGS)

override_dh_auto_configure:
	dh_auto_configure $(DH_FLAGS) -- \
		-DCMAKE_BUILD_TYPE=Release \
		-DBUILD_SHARED_LIBS=ON \
		-DPACKAGE_NAMESPACE=martchus \
		-DNO_LIBSYNCTHING=ON \
		-DQT_PACKAGE_PREFIX=Qt6 \
		-DKF_PACKAGE_PREFIX=KF6

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	QT_QPA_PLATFORM=offscreen $(MAKE) -C $(BUILD_DIR) check
endif

override_dh_auto_build:
	dh_auto_build $(DH_FLAGS)
	ronn --roff debian/man/*.md

override_dh_auto_install:
	dh_auto_install $(DH_FLAGS)

override_dh_auto_clean:
	rm -f debian/man/*.1
	dh_auto_clean $(DH_FLAGS)
